"use strict";

var clc = require('cli-color');
var rek = require('rekuire');

// var console = rek('console');
// var getCwd = rek('getCwd');
var waiting = rek('waiting');
var linksData = rek('linksData');
// var rsync = rek('rsync');
var link = rek('Link').link;
var linksDataUtils = rek('linksDataUtils');


module.exports = {
    createLink: createLink,
    unlink: unlink,
    emptyTrash: emptyTrash,
    show: show,
    run: run
};

function createLink(source, target) {
    console.log(clc.green("Source: " + source));
    console.log(clc.green("Target: " + target));
    linksData.add({ source: source, target: target });
}

function unlink(id) {
    var res = linksData.removeById(id);
    if (!res) {
        return console.log(clc.red("Invalid id or another problem. (id: " + id + ")."));
    }
    return console.log(clc.green("Removed id #" + id));
}

function emptyTrash() {
    linksData.emptyTrash();
    console.log(clc.green("Unlinked links removed from trash."));
}

function show() {
    var all = linksData.all();
    if (all.length == 0) {
        console.log(clc.yellow("There aren't any links defined yet, try something like this:"));
        console.log(clc.green("nsyrc link from ~/thisfolder/ to ~/thatfolder/"));
        return;
    }
    console.log(linksDataUtils.stringifyList(all));
}

function run(id, wet) {
    var linkData = linksData.get(id);
    if (!linkData) {
        return console.log(clc.red("Bad id!"));
    }
    var linkItem = new link(linkData);
    linkItem.run(wet);
}



